import { ElementRef } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { Observable } from 'rxjs/Observable';
import { Subscription } from 'rxjs/Subscription';
import { PartialObserver } from 'rxjs/Observer';
import { CallbackType, SanitizedType } from './prism.type';
export declare class PrismService {
    private sanitizer;
    private subject;
    _async: boolean;
    async: boolean;
    _callback: CallbackType | undefined;
    callback: CallbackType | undefined;
    private templateOptions;
    _code: SanitizedType | undefined;
    code: SanitizedType | undefined;
    _hooks: Object;
    hooks: Object;
    code$: Observable<SanitizedType>;
    language$: Observable<SanitizedType>;
    _interpolation?: Object | undefined;
    interpolation: Object | undefined;
    _language: string;
    language: string;
    private prism;
    constructor(sanitizer: DomSanitizer);
    subscribe(property: 'code' | 'language', observer: PartialObserver<string>): Subscription;
    highlightElement(codeElementRef: ElementRef): void;
    interpolate(codeElementRef: ElementRef): ElementRef;
    private escapeHtml(unsafe);
    private next(property, value);
}
